<?php

/*
Plugin Name: InlineFeed
Plugin URI: http://kruyt.org/wordpress/projects/wp-plugins/
Description: List a RSS-Feed in your WP-Blog, only headlines or with description.
Author: Dennis Kruyt
Version: 1.63
License: GPL
Author URI: http://kruyt.org
Update Server: http://kruyt.org/project/wp-plugin
Min WP Version: 1.5
Max WP Version: 2.1
*/ 

/*

Original and Idea: Dave Wolf, http://www.davewolf.net
Modified by (Version 1.1 rev1): Thomas Fischer, http://www.securityfocus.de
Modified by Frank Bueltge, http://www.bueltge.de/wp-rss-import-plugin/55/

I modified the Frank Bueltge version of this plugin, because his version
needed additional plugins, like exe-php. I wanted a version without the need
of extra plugins and changed a lot more after.
*/

require_once(ABSPATH.'wp-includes/rss-functions.php');

define('MAGPIE_CACHE_ON', false);

/* Optional Plugin Config */
/* Do use php < 4.2, then kill the next comment */
//include(MAGPIE_DIR.'array_change_key_case.php');

function RSSImport($display=0,$feedurl,$displaydescriptions=false,$truncatetitle=true,$newwindow=true) {

    $string = "<!-- start of RSS feed content by InlineFeed plugin - http://kruyt.org -->\n";

    if ( $feedurl ) {
	$rss = fetch_rss( $feedurl );
	// Display a nice error if the feed. Credits to Paul M - http://themineshaftgap.com 
	if ($rss == false){ 
	    $string .= "[InlineFeed plugin cant retrieve: ".substr($feedurl,0,40)."...]"; 
	    return $string; 
	}

		$string .= wptexturize("<br /><b><a href=" . $rss->channel['link'] . ">" . $rss->channel['title'] . ": " . $rss->channel['description'] . "</a></b><br />");
				foreach ($rss->items as $item) {
								if ($display == 0) {
								break;
								}
								$href = $item['link'];
								$desc = trim($item['description']);
								$item['fulltitle']=$item['title'];
									$umlaute = array('','','','','','','','','',"“","?","’","–","—","…","&nbsp;",chr(196), chr(228),chr(214),chr(246),chr(220),chr(252),chr(223),chr(175),chr(174),utf8_encode(''),utf8_encode(''),utf8_encode(''),utf8_encode(''),utf8_encode(''),utf8_encode(''),utf8_encode(''),utf8_encode('?'),utf8_encode(''),utf8_encode(''));
									$htmlcode = array('&auml;','&ouml;','&uuml;','&szlig;','&Auml;','&Ouml;','&Uuml;','&raquo;','&laquo;','"','"','','','','...',' ','&raquo;','&laquo;','&Auml;','&auml;','&Ouml;','&ouml;','&Uuml;','&uuml;','&szlig;','&Auml;','&auml;','&Ouml;','&ouml;','&Uuml;','&uuml;','&szlig;','?','&raquo;','&laquo;');
									$item = str_replace($umlaute, $htmlcode, $item);
									$desc = str_replace($umlaute, $htmlcode, $desc);
								if($truncatetitle){
										if(strlen($item['title'])>55)
												{
														$item['title']=substr($item['title'],0,55)." ... ";
												}
								}
								if($newwindow == 'true' || $newwindow == '1') {
									$target = "_blank";
								} else {
									$target = "_self";
								}
							$string .= wptexturize('<ul><li><a href="'.$href.'" target="'.$target.'" title="'.$item['fulltitle'].'" >'.$item['title'].'</a></li></ul>');
								// Uncomment following line to also display headline description with each headline
								if($displaydescriptions && $desc<>"") {$string .= wptexturize("<div style=\"margin-left: 40px;\">");$string .= wptexturize($desc.'</div>');}
								$display--;
				}
		 }
    $string .= "\n<!-- End of RSS feed content -->\n";
    return $string;
}

// ###


function rssLinkListFilter($content) {

		return preg_replace_callback("/<!--rss:(.*)-->/", "rssMatcher", $content);
}

	if(function_exists('add_filter')){
		add_filter('the_content', 'rssLinkListFilter');
}


function rssMatcher($matches) {
		// get the settings passed in
		$filterSetting = explode(",",$matches[1]);
		$params = array ('rss_feed_url' => $matches[1]);

		// determine if we have more than just a url
		/* loop over the array and break each element up into a sub array like:
				subArray[0] = key
				subArray[1] = value
			*/

		if(count($filterSetting) > 1){
			foreach ($filterSetting as $setting ) {
				$setting = explode(":=",$setting);
				$keyVal = $setting[0];
				$valVal = $setting[1];
				if($valVal == 'true' || $valVal == '1'){
					$valVal = true;
				} elseif ($valVal =='false' || $valVal == '0'){
					$valVal = false;
				}
				// make sure before and after tags are no longer escaped
				$valVal = html_entity_decode($valVal);

				$params[$keyVal] = $valVal;
			}
		} else {
			//handle the origional default settings for when the filter was first added to the plugin

			$params['display'] = 10;
			$params['displaydescriptions'] = true;
			$params['truncatetitle'] = false;
			$params['newwindow'] = false;
		}

	//return print_r($params);
	return RSSImport($params['display'],$params['rss_feed_url'],$params['displaydescriptions'],$params['truncatetitle'],$params['newwindow']);

}

						
?>